/*
 * layout.ld -- MK20DX256 memory layout
 *
 * Copyright (C) 2016 Tomasz Kramkowski <tk@the-tk.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
MEMORY {
	flash : ORIGIN = 0x00000000, LENGTH = 256K
	ram : ORIGIN = 0x1FFF8000, LENGTH = 64K
}

SECTIONS {
	.text : {
		KEEP(*(.vectors))
		. = 0x400;
		KEEP(*(.flashconfig*))
		*(.startup*)
		*(.text*)
		*(.rodata*)
	} >flash

	.data : { *(.data*) } >ram AT>flash

	.bss : { *(.bss*) } >ram

	_sdata = ADDR(.data);
	_edata = ADDR(.data) + SIZEOF(.data);
	_ldata = LOADADDR(.data);

	_sbss = ADDR(.bss);
	_ebss = ADDR(.bss) + SIZEOF(.bss);

	_estack = ORIGIN(ram) + LENGTH(ram);
}
